<?php

namespace Intuit\Models;

use Illuminate\Support\Arr;
use Jenssegers\Model\Model;

use Intuit\Traits\CompareAttributes;

/*
	{#1927
	  +"Name": "Silver retreat"
	  +"Description": "Retreat - silver level"
	  +"Active": true
	  +"SubItem": true
	  +"ParentRef": {#1928
		+"value": "25"
		+"name": "Retreat"
	  }
	  +"Level": 1
	  +"FullyQualifiedName": "Retreat:Silver retreat"
	  +"Taxable": false
	  +"SalesTaxIncluded": false
	  +"UnitPrice": 1000
	  +"Type": "Service"
	  +"IncomeAccountRef": {#1929
		+"value": "1"
		+"name": "Services"
	  }
	  +"PurchaseTaxIncluded": false
	  +"PurchaseCost": 0
	  +"ExpenseAccountRef": {#1930
		+"value": "89"
		+"name": "Purchases"
	  }
	  +"TrackQtyOnHand": false
	  +"SalesTaxCodeRef": {#1931
		+"value": "10"
		+"name": "GST"
	  }
	  +"PurchaseTaxCodeRef": {#1932
		+"value": "2"
		+"name": "GST on non-capital"
	  }
	  +"domain": "QBO"
	  +"sparse": false
	  +"Id": "15"
	  +"SyncToken": "1"
	  +"MetaData": {#1933
		+"CreateTime": "2018-02-21T20:30:11-08:00"
		+"LastUpdatedTime": "2018-06-15T21:19:52-07:00"
	  }
	}
  +"time": "2022-08-13T21:15:37.254-07:00"
 */

final class Item extends Model
{
	use CompareAttributes;

	public function __get($key) {
		$keymap = [
			'id' => 'Id',
			'synctoken' => 'SyncToken',
		];

		switch ($key) {
			case 'created_at':
				return object_get($this->getAttribute('MetaData'),'CreateTime');
			case 'updated_at':
				return object_get($this->getAttribute('MetaData'),'LastUpdatedTime');

			case 'pid':
				return (($x=object_get($this->getAttribute('ParentRef'),'name')) ? $x.':' : '').$this->Name;

			default:
				return parent::__get(Arr::get($keymap,$key,$key));
		}
	}
}